Program MakeCPU;

{ bug fix :
   ZpgeX
   PokeAbso
   PHP, PLP
   IndX,IndY
   stxzy
   txsn : stack overflow on PUSH
   PokeAbso : after PeekAbsX/Y ("peek:=true" was missing)
   CLD  : DFlag not CFlag !!!
   allow SED (for test suite)
   now supporte decimal mode :)
   CMP (NFlag)
   BRK (IFlag)

}


Var
 nz:boolean;
 l1,l2,l3:word;

Type
 TOpCode=record
  Name:array[1..3] of char;
  Parm:array[1..4] of char;
 end;

Const
 OpCode:Array[0..255] of TOpCode = (
 {00-0F}
  (Name:'BRK'; Parm:'Impl'),  (Name:'ORA'; Parm:'IndX'),
  (Name:'JAM'; Parm:'Impl'),  (Name:'SLO'; Parm:'IndX'),
  (Name:'NOP'; Parm:'Zpge'),  (Name:'ORA'; Parm:'ZPge'),
  (Name:'ASL'; Parm:'ZPge'),  (Name:'SLO'; Parm:'ZPge'),
  (Name:'PHP'; Parm:'Impl'),  (Name:'ORA'; Parm:'Imm'),
  (Name:'ASL'; Parm:'Impl'),  (Name:'ANC'; Parm:'Imm'),
  (Name:'NOP'; Parm:'Abso'),  (Name:'ORA'; Parm:'Abso'),
  (Name:'ASL'; Parm:'Abso'),  (Name:'SLO'; Parm:'Abso'),
 {10-1F}
  (Name:'BPL'; Parm:'Rela'),  (Name:'ORA'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'SLO'; Parm:'IndY'),
  (Name:'NOP'; Parm:'ZPgX'),  (Name:'ORA'; Parm:'ZPgX'),
  (Name:'ASL'; Parm:'ZPgX'),  (Name:'   '; Parm:'    '),
  (Name:'CLC'; Parm:'Impl'),  (Name:'ORA'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'   '; Parm:'    '),  (Name:'ORA'; Parm:'AbsX'),
  (Name:'ASL'; Parm:'AbsX'),  (Name:'   '; Parm:'    '),
 {20-2F}
  (Name:'JSR'; Parm:'Abso'),  (Name:'AND'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'RLA'; Parm:'IndX'),
  (Name:'BIT'; Parm:'ZPge'),  (Name:'AND'; Parm:'ZPge'),
  (Name:'ROL'; Parm:'ZPge'),  (Name:'RLA'; Parm:'ZPge'),
  (Name:'PLP'; Parm:'Impl'),  (Name:'AND'; Parm:'Imm'),
  (Name:'ROL'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'BIT'; Parm:'Abso'),  (Name:'AND'; Parm:'Abso'),
  (Name:'ROL'; Parm:'Abso'),  (Name:'RLA'; Parm:'Abso'),
 {30-3F}
  (Name:'BMI'; Parm:'Rela'),  (Name:'AND'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'RLA'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'AND'; Parm:'ZPgX'),
  (Name:'ROL'; Parm:'ZPgX'),  (Name:'RLA'; Parm:'ZPgX'),
  (Name:'SEC'; Parm:'Impl'),  (Name:'AND'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'RLA'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'AND'; Parm:'AbsX'),
  (Name:'ROL'; Parm:'AbsX'),  (Name:'RLA'; Parm:'AbsX'),
 {40-4F}
  (Name:'RTI'; Parm:'Impl'),  (Name:'EOR'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'SRE'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'EOR'; Parm:'ZPge'),
  (Name:'LSR'; Parm:'ZPge'),  (Name:'   '; Parm:'    '),
  (Name:'PHA'; Parm:'Impl'),  (Name:'EOR'; Parm:'Imm '),
  (Name:'LSR'; Parm:'Impl'),  (Name:'ASR'; Parm:'Imm '),
  (Name:'JMP'; Parm:'Abso'),  (Name:'EOR'; Parm:'Abso'),
  (Name:'LSR'; Parm:'Abso'),  (Name:'SRE'; Parm:'Abso'),
 {50-5F}
  (Name:'BVC'; Parm:'Rela'),  (Name:'EOR'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'SRE'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'EOR'; Parm:'ZPgX'),
  (Name:'LSR'; Parm:'ZPgX'),  (Name:'SRE'; Parm:'ZPgX'),
  (Name:'CLI'; Parm:'Impl'),  (Name:'EOR'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'SRE'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'EOR'; Parm:'AbsX'),
  (Name:'LSR'; Parm:'AbsX'),  (Name:'SRE'; Parm:'AbsX'),
 {60-6F}
  (Name:'RTS'; Parm:'Impl'),  (Name:'ADC'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'RRA'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'ADC'; Parm:'ZPge'),
  (Name:'ROR'; Parm:'ZPge'),  (Name:'RRA'; Parm:'ZPge'),
  (Name:'PLA'; Parm:'Impl'),  (Name:'ADC'; Parm:'Imm'),
  (Name:'ROR'; Parm:'Impl'),  (Name:'ARR'; Parm:'Imm'),
  (Name:'JMP'; Parm:'Ind '),  (Name:'ADC'; Parm:'Abso'),
  (Name:'ROR'; Parm:'Abso'),  (Name:'RRA'; Parm:'Abso'),
 {70-7F}
  (Name:'BVS'; Parm:'Rela'),  (Name:'ADC'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'RRA'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'ADC'; Parm:'ZPgX'),
  (Name:'ROR'; Parm:'ZPgX'),  (Name:'RRA'; Parm:'ZPgX'),
  (Name:'SEI'; Parm:'Impl'),  (Name:'ADC'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'RRA'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'ADC'; Parm:'AbsX'),
  (Name:'ROR'; Parm:'AbsX'),  (Name:'RRA'; Parm:'AbsX'),
 {80-8F}
  (Name:'NOP'; Parm:'Imm '),  (Name:'STA'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'SAX'; Parm:'IndX'),
  (Name:'STY'; Parm:'ZPge'),  (Name:'STA'; Parm:'ZPge'),
  (Name:'STX'; Parm:'ZPge'),  (Name:'SAX'; Parm:'ZPge'),
  (Name:'DEY'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'TXA'; Parm:'Impl'),  (Name:'ANE'; Parm:'Imm '),
  (Name:'STY'; Parm:'Abso'),  (Name:'STA'; Parm:'Abso'),
  (Name:'STX'; Parm:'Abso'),  (Name:'SAX'; Parm:'Abso'),
 {90-9F}
  (Name:'BCC'; Parm:'Rela'),  (Name:'STA'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'SHA'; Parm:'IndY'),
  (Name:'STY'; Parm:'ZPgX'),  (Name:'STA'; Parm:'ZPgX'),
  (Name:'STX'; Parm:'ZPgY'),  (Name:'SAX'; Parm:'ZpgX'),
  (Name:'TYA'; Parm:'Impl'),  (Name:'STA'; Parm:'AbsY'),
  (Name:'TXS'; Parm:'Impl'),  (Name:'SHS'; Parm:'AbsY'),
  (Name:'SHY'; Parm:'AbsX'),  (Name:'STA'; Parm:'AbsX'),
  (Name:'SHX'; Parm:'AbsY'),  (Name:'SHA'; Parm:'AbsY'),
 {A0-AF}
  (Name:'LDY'; Parm:'Imm'),   (Name:'LDA'; Parm:'IndX'),
  (Name:'LDX'; Parm:'Imm'),   (Name:'LAX'; Parm:'IndX'),
  (Name:'LDY'; Parm:'ZPge'),  (Name:'LDA'; Parm:'ZPge'),
  (Name:'LDX'; Parm:'ZPge'),  (Name:'LAX'; Parm:'ZPge'),
  (Name:'TAY'; Parm:'Impl'),  (Name:'LDA'; Parm:'Imm'),
  (Name:'TAX'; Parm:'Impl'),  (Name:'LXA'; Parm:'Imm '),
  (Name:'LDY'; Parm:'Abso'),  (Name:'LDA'; Parm:'Abso'),
  (Name:'LDX'; Parm:'Abso'),  (Name:'LAX'; Parm:'Abso'),
 {B0-BF}
  (Name:'BCS'; Parm:'Rela'),  (Name:'LDA'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'LAX'; Parm:'IndY'),
  (Name:'LDY'; Parm:'ZPgX'),  (Name:'LDA'; Parm:'ZpgX'),
  (Name:'LDX'; Parm:'ZPgY'),  (Name:'LAX'; Parm:'ZpgY'),
  (Name:'CLV'; Parm:'Impl'),  (Name:'LDA'; Parm:'AbsY'),
  (Name:'TSX'; Parm:'Impl'),  (Name:'LAS'; Parm:'AbsY'),
  (Name:'LDY'; Parm:'AbsX'),  (Name:'LDA'; Parm:'AbsX'),
  (Name:'LDX'; Parm:'AbsY'),  (Name:'LAX'; Parm:'AbsY'),
 {C0-CF}
  (Name:'CPY'; Parm:'Imm '),  (Name:'CMP'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'DCP'; Parm:'IndX'),
  (Name:'CPY'; Parm:'ZPge'),  (Name:'CMP'; Parm:'ZPge'),
  (Name:'DEC'; Parm:'ZPge'),  (Name:'DCP'; Parm:'ZPge'),
  (Name:'INY'; Parm:'Impl'),  (Name:'CMP'; Parm:'Imm'),
  (Name:'DEX'; Parm:'Impl'),  (Name:'SBX'; Parm:'Imm '),
  (Name:'CPY'; Parm:'Abso'),  (Name:'CMP'; Parm:'Abso'),
  (Name:'DEC'; Parm:'Abso'),  (Name:'DCP'; Parm:'Abso'),
 {D0-DF}
  (Name:'BNE'; Parm:'Rela'),  (Name:'CMP'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'DCP'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'   '; Parm:'    '),
  (Name:'DEC'; Parm:'ZPgX'),  (Name:'DCP'; Parm:'ZPgX'),
  (Name:'CLD'; Parm:'Impl'),  (Name:'CMP'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'DCP'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'CMP'; Parm:'AbsX'),
  (Name:'DEC'; Parm:'AbsX'),  (Name:'DCP'; Parm:'AbsX'),
 {E0-EF}
  (Name:'CPX'; Parm:'Imm' ),  (Name:'SBC'; Parm:'IndX'),
  (Name:'   '; Parm:'    '),  (Name:'ISB'; Parm:'IndX'),
  (Name:'CPX'; Parm:'ZPge'),  (Name:'SBC'; Parm:'ZPge'),
  (Name:'INC'; Parm:'ZPge'),  (Name:'ISB'; Parm:'ZPge'),
  (Name:'INX'; Parm:'Impl'),  (Name:'SBC'; Parm:'Imm'),
  (Name:'NOP'; Parm:'Impl'),  (Name:'   '; Parm:'    '),
  (Name:'CPX'; Parm:'Abso'),  (Name:'SBC'; Parm:'Abso'),
  (Name:'INC'; Parm:'Abso'),  (Name:'ISB'; Parm:'Abso'),
 {F0-FF}
  (Name:'BEQ'; Parm:'Rela'),  (Name:'SBC'; Parm:'IndY'),
  (Name:'D64'; Parm:'Imm' ),  (Name:'ISB'; Parm:'IndY'),
  (Name:'   '; Parm:'    '),  (Name:'SBC'; Parm:'ZPgX'),
  (Name:'INC'; Parm:'ZPgX'),  (Name:'ISB'; Parm:'ZPgX'),
  (Name:'SED'; Parm:'Impl'),  (Name:'SBC'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'ISB'; Parm:'AbsY'),
  (Name:'   '; Parm:'    '),  (Name:'SBC'; Parm:'AbsX'),
  (Name:'INC'; Parm:'AbsX'),  (Name:'ISB'; Parm:'AbsX')
  );

 OpCycles:array[0..255] of byte=(
   { 0 1 2 3 4 5 6 7 8 9 A B C D E F 0 1 2 3 4 5 6 7 8 9 A B C D E F}
{00} 7,6,0,8,3,3,5,5,3,2,2,2,4,4,6,6,2,5,0,8,4,4,6,6,2,4,0,7,0,4,7,7,
{20} 6,6,0,8,3,3,5,5,4,2,2,0,4,4,6,0,2,5,0,8,0,4,6,6,2,4,0,7,0,4,7,7,
{40} 6,6,0,8,0,3,5,0,3,2,2,2,3,4,6,6,2,5,0,8,0,4,6,6,2,4,0,7,0,4,7,0,
{60} 6,6,0,8,0,3,5,5,4,2,2,0,5,4,6,6,2,5,0,8,0,4,6,6,2,4,0,7,0,4,7,7,
{80} 2,6,0,6,3,3,3,3,2,0,2,2,4,4,4,4,2,5,0,5,4,4,4,4,2,4,2,5,5,4,5,5,
{A0} 2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4,2,5,0,5,4,4,4,4,2,4,2,4,4,4,4,4,
{C0} 2,6,0,8,3,3,5,5,2,2,2,2,4,4,6,6,2,5,0,8,0,4,6,6,2,4,0,7,0,4,7,7,
{E0} 2,6,0,8,3,3,5,5,2,2,2,0,4,4,6,6,2,5,0,8,0,4,6,6,2,4,0,7,0,4,7,7
 );

Var
 IR:byte;
 lbl:word;
 head:boolean;
 peek:boolean;

Function JUMP(Cond:string):word;
 begin
  JUMP:=lbl;
  WriteLn(' ',Cond,' lbl',lbl); inc(lbl);
 end;

Procedure Target(Lbl:word);
 begin
  WriteLn(' lbl',lbl,':');
 end;

function hexa(b:byte):string;
 const
  hx:array[0..15] of char='0123456789ABCDEF';
 begin
  hexa:=hx[b shr 4]+hx[b and 15]
 end;

Procedure Header;
 begin
 (*
  WriteLn(';--',Hexa(IR),'--',OpCode[IR].Name,' ',OpCode[IR].Parm,'--',OpCycles[IR],'--');
  WriteLn('Align 2');
  WriteLn('op',Hexa(IR),':');
 *)
  if not head then begin
   WriteLn(';--',OpCode[IR].Name,' ',OpCode[IR].Parm,' ',OpCycles[IR],'--');
   WriteLn('OpCode ',Hexa(IR));
   head:=true;
  end;
 end;

Procedure Fetch;
 begin
  Header;
  WriteLn(' INC PC');
 end;

Procedure Next;
 begin
  writeln('; cycles');
  writeln(' MOV CX,',OpCycles[IR]);
  writeln('JMP Next');
 end;


Procedure SetFlag(Flag:string; on:boolean);
 begin
  Header;
  if on then
   WriteLn(' OR P,',Flag)
  else
   WriteLn(' AND P,255-',Flag);
  Next;
 end;

Procedure Set_NZ(Reg:String);
 begin
 (*
  Writeln('; Set_NZ');
  writeln(' OR AL,AL');
  writeln(' JZ lbl',lbl); inc(lbl);
  writeln('  TEST AL,NFlag');
  writeln('  JZ lbl',lbl); inc(lbl);
  writeln('   AND P,255-ZFlag');
  writeln('   OR  P,NFlag');
  writeln('  JMP lbl',lbl); inc(lbl);
  writeln(' lbl',lbl-2,':');
  writeln('  AND P,255-ZFlag-NFlag');
  writeln('  JMP lbl',lbl-1);
  writeln(' lbl',lbl-3,':');
  writeln('  AND P,255-NFlag');
  writeln('  OR  P,ZFlag');
  writeln(' lbl',lbl-1,':');
 *)
  if not nz then WriteLn(' Set_NZ ',Reg);
  nz:=true;
 end;

Procedure Push(Load:string);
 begin
  Header;
  writeln(load);
  WriteLn(' MOV BX,S');
  writeln(' MOV RAM:[BX],AL');
  writeln(' DEC BL');
  writeln(' MOV S,BX');
 end;

procedure Pop(Store:string);
 begin
  Header;
  Writeln(' MOV BX,S');
  writeln(' INC BL');
  WriteLn(' MOV AL,RAM:[BX]');
  writeln(' MOV S,BX');
  writeln(Store);
 end;

Procedure PHP;
 begin
  Header;
  WriteLn(' MOV AL,P');
  WriteLn(' OR AL,BFlag');
  WriteLn(' MOV BX,S');
  writeln(' MOV FS:[BX],AL');
  writeln(' DEC BL');
  writeln(' MOV S,BX');
  Next;
 end;

Procedure PLP;
 begin
  Header;
  Writeln(' MOV BX,S');
  writeln(' INC BL');
  WriteLn(' MOV AL,RAM:[BX]');
  writeln(' MOV S,BX');
  WriteLn(' AND AL,255-BFlag');
  WriteLn(' OR  AL,_Flag');
  WriteLn(' MOV P,AL');
  Next;
 end;

Procedure Imm;
 begin
  Header;
  WriteLn(' INC PC');
  WriteLn(' MOV AL,BL');
  WriteLn(' XOR AH,AH'); {------------------}
 end;

Procedure LDA;
 begin
  Header;
  WriteLn(' MOV AX,A');
 end;

Procedure LDX;
 begin
  Header;
  WriteLn(' MOV AX,X');
 end;

Procedure STX(Reg:String);
 begin
  WriteLn(' MOV BYTE PTR X,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure LDY;
 begin
  Header;
  WriteLn(' MOV AX,Y');
 end;

Procedure STY(Reg:string);
 begin
  WriteLn(' MOV BYTE PTR Y,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure STA(Reg:string);
 begin
  WriteLn(' MOV BYTE PTR A,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure PeekZPge;
 begin
  header;
  WriteLn('; peek zpge');
  writeln(' INC PC');
  writeln(' XOR BH,BH');
  writeln(' MOV AL,RAM:[BX]');
  WriteLn(' XOR AH,AH'); {------------------}
  peek:=true;
 end;

Procedure PokeZPge;
 begin
  if not peek then begin
   writeln(' INC PC');
   writeln(' XOR BH,BH');
  end;
  WriteLn('; cycles');
  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeBX');
 end;

Procedure PeekZPgX;
 begin
  header;
  WriteLn('; peek zpgx');
  writeln(' INC PC');
  writeln(' ADD BX,X');
  writeln(' XOR BH,BH');
  writeln(' MOV AL,RAM:[BX]');
  WriteLn(' XOR AH,AH'); {------------------}
  peek:=true;
 end;

Procedure PokeZPgX;
 begin
  WriteLn('; poke zpge');
  writeln(' INC PC');
  writeln(' ADD BX,X');
  writeln(' XOR BH,BH');
  writeln(' MOV CX,',OpCycles[IR]);
  writeln('JMP PokeBX');
 end;

Procedure PeekZPgY;
 begin
  header;
  WriteLn('; peek zpgy');
  writeln(' INC PC');
  writeln(' ADD BX,Y');
  writeln(' XOR BH,BH');
  writeln(' MOV AL,RAM:[BX]');
  WriteLn(' XOR AH,AH'); {------------------}
  peek:=true;
 end;

Procedure PokeZPgY;
 begin
  header;
  WriteLn('; poke zpgy');
  writeln(' INC PC');
  writeln(' ADD BX,Y');
  writeln(' XOR BH,BH');
  writeln(' MOV CX,',OpCycles[IR]);
  writeln('JMP PokeBX');
 end;

Procedure PeekAbso;
 begin
  Header;
  WriteLn('; peek abso');
  writeln(' INC PC');
  writeln(' INC PC');
  writeln(' Call PeekBX ; AL');
  peek:=true;
 end;

Procedure PeekAbsX;
 begin
  Header;
  WriteLn('; peek absx');
  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,X');
  writeln(' Call PeekBX ; AL');
  peek:=true;
 end;

Procedure PokeAbsX;
 begin
  WriteLn('; poke Absx');
  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,X');
  WriteLn(' MOV CX,',OpCycles[IR]);
  writeln('JMP PokeBX ; AL');
 end;

Procedure PeekAbsY;
 begin
  Header;
  WriteLn('; peek absy');
  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,Y');
  writeln(' Call PeekBX ; AL');
  peek:=true;
 end;

Procedure PokeAbsY;
 begin
  WriteLn('; poke AbsY');
  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,Y');
  WritELn(' MOV CX,',OpCycles[IR]);
  writeln('JMP PokeBX');
 end;

Procedure PokeAbso;
 begin
  if not peek then begin
   WriteLn(' INC PC');
   WriteLn(' INC PC');
  end;
  WriteLn('; cycles');
  writeln(' MOV CX,',OpCycles[IR]);
  if peek then
   writeln('JMP PokeDI') { !!! Peek destroy BX ! }
  else
   writeln('JMP PokeBX');
 end;

Procedure PeekIndX;
 begin
  Header;
  WriteLn('; peek indx');
  WriteLn(' INC PC');
  WriteLn(' ADD BX,X');
  WriteLn(' XOR BH,BH');
  WriteLn(' MOV BX,RAM:[BX]');
  WriteLn(' Call PeekBX ; AL');
  peek:=true;
 end;

Procedure PokeIndX;
 begin
  if peek=false then begin
   WriteLn('; poke indx');
   WriteLn(' INC PC');
   WriteLn(' ADD BX,X');
   WriteLn(' XOR BH,BH');
   WriteLn(' MOV BX,RAM:[BX]');
   writeln(' MOV CX,',OpCycles[IR]);
   WriteLn('JMP PokeBX ; AL');
  end else begin
   writeln(' MOV CX,',OpCycles[IR]);
   WriteLn('JMP PokeDI ; AL');
  end;
 end;

Procedure PeekIndY;
 begin
  Header;
  WriteLn('; peek indy');
  WriteLn(' INC PC');
  WriteLn(' XOR BH,BH');
  WriteLn(' MOV BX,RAM:[BX]');
  WriteLn(' ADD BX,Y');
  WriteLn(' Call PeekBX ; AL');
  peek:=true;
 end;

Procedure PokeIndY;
 begin
  if not peek then begin
   WriteLn('; poke indy');
   WriteLn(' INC PC');
   WriteLn(' XOR BH,BH');
   WriteLn(' MOV BX,RAM:[BX]');
   WriteLn(' ADD BX,Y');
   writeln(' MOV CX,',OpCycles[IR]);
   WriteLn('JMP PokeBX ; AL');
  end else begin
   writeln(' MOV CX,',OpCycles[IR]);
   WriteLn('JMP PokeDI ; AL');
  end;
 end;

Procedure Branch(Flag:string; On:boolean);
 begin
  Header;
  WriteLn(' INC PC');
  WriteLn(' TEST P,',Flag);
  if on then
   writeln(' JZ lbl',lbl)
  else
   writeln(' JNZ lbl',lbl);
  inc(lbl);
  writeln('  MOV AL,BL');
  writeln('  CBW');
  writeln('  ADD PC,AX');
  writeln(' lbl',lbl-1,':');
  Next;
 end;

Procedure BRK;
 begin
  Header;
  WriteLn(' IF DEBUG');
  WriteLn('  CALLP dbgBRK');
  WriteLn(' ENDIF');
  writeln('; push pc');
  WriteLn(' MOV AX,PC');
  Writeln(' INC AX');
{  WriteLn(' INC AX'); }

  WriteLn(' MOV BX,S');
  WriteLn(' MOV RAM:[BX],AH');
  WriteLn(' DEC BL');
  WriteLn(' MOV RAM:[BX],AL');
  WriteLn(' DEC BL');

  writeln('; push (p or BFlag)');
  writeln(' MOV AL,P');
  writeln(' OR  AL,BFlag');
  writeln(' MOV RAM:[BX],AL');
  writeln(' DEC BL');
  writeln(' MOV S,BX');
  writeln('; IFlag');
  writeln(' OR P,IFlag');
  writeln('; pc=peekw($FFFE)');
  writeln(' MOV BX,0FFFEh');
  writeln(' CALL DeekBX');
  writeln(' MOV PC,BX');
  Next;
 end;

Procedure ORA(Reg:string);
 begin
  WriteLn(' OR  ',Reg,',BYTE PTR A');
  WriteLn(' MOV BYTE PTR A,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure EOR;
 begin
  WriteLn(' XOR AL,Byte ptr A');
  WriteLn(' MOV Byte ptr A,AL');
  Set_NZ('AL');
  Next;
 end;

Procedure AND_;
 begin
  WriteLn(' AND AX,A');
  WriteLn(' MOV A,AX');
  Set_NZ('AL');
  Next;
 end;

Procedure ASL;
 begin
  writeln(' SHR P,1');
  WriteLn(' SHL AL,1');
  WriteLn(' RCL P,1');
  Set_NZ('AL');
 end;

Procedure LSR;
 begin
  writeln(' SHR P,1');
  WriteLn(' SHR AL,1');
  WriteLn(' RCL P,1');
  Set_NZ('AL');
 end;

Procedure ROL;
 begin
  writeln(' SHR P,1');
  WriteLn(' RCL AL,1');
  WriteLn(' RCL P,1');
  Set_NZ('AL');
 end;

Procedure ROR;
 begin
  writeln(' SHR P,1');
  WriteLn(' RCR AL,1');
  WriteLn(' RCL P,1');
  Set_NZ('AL');
 end;

Procedure BIT;
 begin
  WriteLn(' AND P,255-VFlag-NFlag-ZFlag');
  WriteLn(' MOV AH,BYTE PTR A');
  WriteLn(' AND AH,AL');
  WriteLn(' JNZ lbl',lbl); inc(lbl);
  WriteLn('  OR P,ZFlag');
  writeln(' lbl',lbl-1,':');
  writeln(' AND AL,VFlag+NFlag');
  WriteLn(' OR  P,AL');
  Next;
 end;

Procedure RTI;
 begin
  Header;
  WriteLn(' MOV BX,S');
  WriteLn(' INC BL');
  WriteLn(' MOV AL,RAM:[BX]');
  WriteLn(' AND AL,255-BFlag'); { ? }
  WriteLn(' OR  AL,_Flag');
  WriteLn(' MOV P,AL');

  WriteLn(' INC BL');
  WriteLn(' MOV AL,RAM:[BX]');
  WriteLn(' INC BL');
  WriteLn(' MOV AH,RAM:[BX]');

  WriteLn(' MOV PC,AX');
  WriteLn(' MOV S,BX');
  Next;
 end;

Procedure JSR;
 begin
  Header;
  WriteLn(' MOV AX,PC');
  WriteLn(' MOV PC,BX'); { !!! }
  WriteLn(' INC AX');
  WriteLn(' MOV BX,S');

  WriteLn(' MOV RAM:[BX],AH');
  WriteLn(' DEC BL');
  WriteLn(' MOV RAM:[BX],AL');
  WriteLn(' DEC BL');

  WriteLn(' MOV S,BX');
  Next;
 end;

Procedure JMPInd;
 begin
  Header;
  WriteLn(' Call DeekBX ; BX ');
  WriteLn(' MOV PC,BX');
  Next;
 end;

Procedure RTS;
 begin
  Header;
  WriteLn(' MOV BX,S');

  WriteLn(' INC BL');
  WriteLn(' MOV AL,RAM:[BX]');
  WriteLn(' INC BL');
  WriteLn(' MOV AH,RAM:[BX]');

  WriteLn(' INC AX');
  WriteLn(' MOV PC,AX');
  WriteLn(' MOV S,BX');
  Next;
 end;

Procedure ADC;
 begin
  writeln(' Call doADC');
  Next;
 end;

Procedure SBC;
 begin
  Writeln(' Call doSBC');
  Next;
 end;

Procedure DEC_;
 begin
  WriteLn(' DEC AL');
  WriteLn(' Set_NZ AL');
 end;

Procedure INC_;
 begin
  WriteLn(' INC AL');
  WriteLn(' Set_NZ AL');
 end;

Procedure CMP(What:string);
 begin
  Header;

  WriteLn('  AND P,255-NFlag-ZFlag-CFlag');
  WriteLn('  XOR CX,CX');
  WriteLn('  CMP BYTE PTR ',What); { Reg,Value }

  WriteLn('  JC  lbl',lbl); inc(lbl);
  WriteLn('   MOV CL,CFlag');
  WriteLn('  lbl',lbl-1,':');

  WriteLn('  JNS lbl',lbl); inc(lbl);
  WriteLn('   MOV CH,NFlag');
  WriteLn('  lbl',lbl-1,':');

  WriteLn('  JNZ lbl',lbl); inc(lbl);
  Writeln('   OR  CL,ZFlag');
  WriteLn('  lbl',lbl-1,':');

  WriteLn('  OR CL,CH');
  WriteLn('  OR P,CL');

  Next;
 end;

{ Undocumented opcodes }

Procedure SLO; { ASO }
 begin
  WriteLn(' SHR P,1');   { CFlag = AL and 1 }
  Writeln(' SHL AL,1');  { ShiftLeft }
  WriteLn(' RCL P,1');
  WriteLn(' OR  BYTE PTR A,AL'); { ora }
  WriteLn(' MOV AH,BYTE PTR A');
  Set_NZ('AH');
 end;

Procedure SRE; { LSE }
 begin
  WriteLn(' SHR P,1');   { CFlag = AL and 1 }
  Writeln(' SHR AL,1');  { ShiftRight }
  WriteLn(' RCL P,1');
  WriteLn(' XOR BYTE PTR A,AL'); { Eor }
  WriteLn(' MOV AH,BYTE PTR A');
  Set_NZ('AH');
 end;

Procedure ANC;
 begin
  WriteLn(' AND AX,A');
  WriteLn(' MOV A,AX');
  Set_NZ('AL');
  WriteLn(' SHR P,1');
  WriteLn(' SHL AL,1');
  WriteLn(' RCL P,1');
  Next;
 end;

Procedure RLA;
 begin
  writeln(' SHR P,1');  { ROL }
  WriteLn(' RCL AL,1');
  WriteLn(' RCL P,1');
  WriteLn(' AND BYTE PTR A,AL'); { AND }
  WriteLn(' MOV AH,BYTE PTR A');
  Set_NZ('AH');
 end;

Procedure ASR;
 begin
  WriteLn(' AND AL,BYTE PTR A');
  WriteLn(' SHR P,1');
  WriteLn(' SHR AL,1');
  WriteLn(' RCL P,1');
  WriteLn(' MOV BYTE PTR A,AL');
  Set_NZ('AL');
  Next;
 end;

Procedure RRA; { not finish }
 begin
  WriteLn(' SHR P,1');
  WriteLn(' RCR AL,1');  { ROR }
  WriteLn(' RCL P,1');

  WriteLn(' PUSH AX');
  WriteLn(' PUSH BX');

  WriteLn(' CALL doADC');

  WriteLn(' POP  BX');
  WriteLn(' POP  AX');
 end;

Procedure SAX;
 begin
  Header;
  WriteLn(' MOV AL,BYTE PTR A');
  WriteLn(' AND AL,BYTE PTR X');
 end;

Procedure ANE;
 begin
  WriteLn(' AND AL,BYTE PTR X');
  WriteLn(' MOV AH,BYTE PTR A');
  WriteLn(' OR  AH,0EEh');
  WriteLn(' AND AL,AH');
  WriteLn(' MOV BYTE PTR A,AL');
  Set_NZ('AL');
  Next;
 end;

Procedure SHAIndY;
 begin
  Header;

  WriteLn(' INC PC');
  WriteLn(' XOR BH,BH');

  WriteLn(' MOV DI,RAM:[BX]');
  WriteLn(' ADD DI,Y');

  WriteLn(' INC BL');
  WriteLn(' MOV AL,RAM:[BX]');
  WriteLn(' INC AL');
  WriteLn(' AND AL,BYTE PTR X');{ AND X }
  WriteLn(' AND AL,BYTE PTR A');{ AND A }

  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeDI ; AL');
 end;

Procedure SHAAbsY;
 begin
  Header;

  WriteLn(' MOV AL,BH'); { PC[+2] }
  WriteLn(' INC AL');    { +1 }
  WriteLn(' AND AL,BYTE PTR A');{ AND A }
  WriteLn(' AND AL,BYTE PTR X');{ AND X }

  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,Y'); { AbsY }

  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeBX ; AL');

 end;

Procedure SHSAbsY;
 begin
  Header;

  WriteLn(' MOV AH,BYTE PTR A');
  WriteLn(' AND AH,BYTE PTR X');
  WriteLn(' MOV BYTE PTR S,AH');

  WriteLn(' MOV AL,BH'); { PC[+2] }
  WriteLn(' INC AL');    { +1 }
  WriteLn(' AND AL,AH');

  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,Y'); { AbsY }

  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeBX ; AL');
 end;

Procedure SHYAbsX;
 begin
  Header;

  WriteLn(' MOV AL,BH'); { PC[+2] }
  WriteLn(' INC AL');    { +1 }
  WriteLn(' AND AL,BYTE PTR Y');{ AND X }

  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,X'); { AbsX }

  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeBX ; AL');
 end;

Procedure SHXAbsY;
 begin
  Header;

  WriteLn(' MOV AL,BH'); { PC[+2] }
  WriteLn(' INC AL');    { +1 }
  WriteLn(' AND AL,BYTE PTR X');{ AND X }

  Writeln(' INC PC');
  Writeln(' INC PC');
  WriteLn(' ADD BX,Y'); { AbsY }

  writeln(' MOV CX,',OpCycles[IR]);
  WriteLn('JMP PokeBX ; AL');
 end;

Procedure LAX(Reg:string);
 begin
  WriteLn(' MOV BYTE PTR A,',Reg);
  WriteLn(' MOV BYTE PTR X,',Reg);
  Set_NZ(Reg);
  Next;
 end;

Procedure LXA;
 begin
  WriteLn(' MOV AH,BYTE PTR A');
  WriteLn(' OR  AH,0EEh');
  WriteLn(' AND AL,AH');
  WriteLn(' MOV BYTE PTR A,AL');
  WriteLn(' MOV BYTE PTR X,AL');
  Set_NZ('AL');
  Next;
 end;

Procedure LAS;
 begin
  WriteLn(' AND AL,BYTE PTR S');
  WriteLn(' MOV BYTE PTR S,AL');
  WriteLn(' MOV BYTE PTR X,AL');
  WriteLn(' MOV BYTE PTR A,AL');
  Set_Nz('AL');
  Next;
 end;

Procedure DCP;  { DCM }
 begin
  Header;

  WriteLn('  DEC AL'); { DEC }

  WriteLn('  AND P,255-NFlag-ZFlag-CFlag');
  WriteLn('  XOR CX,CX');
  WriteLn('  CMP BYTE PTR A,AL'); { CMP }

  WriteLn('  JC  lbl',lbl); inc(lbl);
  WriteLn('   MOV CL,CFlag');
  WriteLn('  lbl',lbl-1,':');

  WriteLn('  JNS lbl',lbl); inc(lbl);
  WriteLn('   MOV CH,NFlag');
  WriteLn('  lbl',lbl-1,':');

  WriteLn('  JNZ lbl',lbl); inc(lbl);
  Writeln('   OR  CL,ZFlag');
  WriteLn('  lbl',lbl-1,':');

  WriteLn('  OR CL,CH');
  WriteLn('  OR P,CL');

{  Next; }
 end;

Procedure SBX;
 begin
  WriteLn(' MOV AL,BYTE PTR A');
  WriteLn(' AND AL,BYTE PTR X'); { AND A,X }
  WriteLn(' SUB AL,BL ; Imm');   { SBC Imm }
  WriteLn(' MOV BYTE PTR X,AL');
  WriteLn(' SETNC AH');
  Set_NZ('AL');
  WriteLn(' SHR P,1');
  WriteLn(' SHR AH,1');
  WriteLn(' RCL P,1');
  Next;
 end;

Procedure ISB; { INS }
 begin
  WriteLn(' INC AL'); { INC }
  WriteLn(' PUSH AX');
  WriteLn(' PUSH BX');
  WriteLn(' CALL doSBC');
  WriteLn(' POP  BX');
  WriteLn(' POP  AX');
 end;

Procedure ARR;
{Undocumented instruction: AND and ROR, CF = bit 6, VF = bit 5 ^ bit 6}
 begin
  WriteLn(' AND BL,BYTE PTR A'); { AND Imm }
  WriteLn(' MOV AL,BL');
  Writeln(' SHR P,1');
  WriteLn(' RCR AL,1');          { ROR }
  WriteLn(' SHL P,1');

  Set_NZ('AL');

  WriteLn(' TEST P,DFlag');
  WriteLn(' JNZ ARR_DecMode');

  WriteLn(' MOV BYTE PTR A,AL');

  Writeln(' TEST AL,40h');
  WriteLn(' JZ ARR_NoCarry');
  WriteLn('  OR P,CFlag');
  WriteLn(' ARR_NoCarry:');

  WriteLn(' AND P,255-VFlag');
  WriteLn(' MOV AH,AL');
  WriteLn(' SHR AH,1 ');
  WriteLn(' AND AX,2020h');
  WriteLn(' XOR AL,AH');
  WriteLn(' JZ ARR_NotOver');
  WriteLn('  OR P,VFlag');
  WriteLn(' ARR_NotOver:');
  WriteLn(' JMP ARR_Done');

  WriteLn(' ARR_DecMode:');

  WriteLn(' AND P,255-VFlag-CFlag');
  WriteLn(' MOV AH,BL');
  WriteLn(' XOR AH,AL');
  WriteLn(' AND AH,40h');
  WriteLn(' JZ ARRDec_NotOver');
  WriteLn('  OR P,VFlag');
  WriteLn(' ARRDec_NotOver:');

  WriteLn(' MOV BH,BL');
  WriteLn(' MOV CX,BX');
  WriteLn(' AND CX,010Fh');
  WriteLn(' ADD CL,CH');
  WriteLn(' CMP CL,6');
  WriteLn(' JB  ARR_NoAdjLow');
  WriteLn('  MOV AH,AL');
  WriteLn('  ADD AL,6');
  WriteLn('  AND AX,0F00Fh');
  WriteLn('  OR  AL,AH');
  WriteLn(' ARR_NoAdjLow:');

  WriteLn(' AND BX,10F0h');
  WriteLn(' ADD BL,BH');
  WriteLn(' JC ARR_IncHigh');
  WriteLn('  CMP BL,60h');
  WriteLn('  JB  ARR_DecDone');
  WriteLn(' ARR_IncHigh:');
  WriteLn(' OR  P,CFlag');
  WriteLn(' MOV AH,AL');
  Writeln(' ADD AL,60h');
  WriteLn(' AND AX,0FF0h');
  WriteLn(' OR  AL,AH');

  WriteLn(' ARR_DecDone:');
  WriteLn(' MOV BYTE PTR A,AL');

  WriteLn(' ARR_Done:');

  Next;
 end;

Procedure RunCPU;
begin
  nz:=false;
  head:=false;
  peek:=false;
  writeln;
  case IR of
   $00 { BRK      } : BRK;
   $01 { ORA IndX } : begin PeekIndX; ORA('AL'); end;
 { $02-JAM}
{*}$03 { SLO IndX } : begin PeekIndX; SLO; PokeIndX; end;
{*}$04 { NOP Zpge } : begin Header; WriteLn(' INC PC'); Next end;
   $05 { ORA ZPge } : begin PeekZPge; ORA('AL'); end;
   $06 { ASL ZPge } : begin PeekZPge; ASL; PokeZPge; end;
{*}$07 { SLO ZPge } : begin PeekZPge; SLO; PokeZPge; end;
   $08 { PHP      } : PHP;
   $09 { ORA Imm  } : begin Fetch; ORA('BL'); end;
   $0A { ASL      } : begin LDA; ASL; STA('AL'); end;
{*}$0B { ANC Imm  } : begin Imm; ANC; end;
{*}$0C { NOP Abso } : begin Header; WriteLn(' ADD PC,2'); Next end;
   $0D { ORA Abso } : begin PeekAbso; ORA('AL'); end;
   $0E { ASL Abso } : begin PeekAbso; ASL; PokeAbso end;
{*}$0F { SLO Abso } : begin PeekAbso; SLO; PokeAbso; end;
   $10 { BPL Rela } : Branch('NFlag',False);
   $11 { ORA IndY } : begin PeekIndY; ORA('AL'); end;
 { $12-JAM}
{*}$13 { SLO IndY } : begin PeekIndY; SLO; PokeIndY; end;
{*}$14 { NOP ZpgX } : begin Header; WriteLn(' INC PC'); Next end;
   $15 { ORA ZPgX } : begin PeekZPgX; ORA('AL'); end;
   $16 { ASL ZPgX } : begin PeekZPgX; ASL; PokeZPge; end;
{*}$17 { SLO ZPgX } : begin PeekZPgX; SLO; PokeZPge; end;
   $18 { CLC      } : SetFlag('CFlag',False);
   $19 { ORA AbsY } : begin PeekAbsY; ORA('AL') end;
{*}$1A { NOP      } : WriteLn('op1A equ opEA ; undocumented NOP');
{*}$1B { SLO AbsY } : begin PeekAbsY; SLO; PokeAbso; end;
{*}$1C { NOP      } : WriteLn('op1C equ op0C ; undocumented NOP');
   $1D { ORA AbsX } : begin PeekAbsX; ORA('AL') end;
   $1E { ASL AbsX } : begin PeekAbsX; ASL; PokeAbso end;
{*}$1F { SLO AbsX } : begin PeekAbsX; SLO; PokeAbso; end;
   $20 { JSR Abso } : JSR;
   $21 { AND IndX } : begin PeekIndX; AND_ end;
 { $22-JAM}
{*}$23 { RLA IndX } : begin PeekIndX; RLA; PokeIndX end;
   $24 { BIT ZPge } : begin PeekZPge; BIT end;
   $25 { AND ZPge } : begin PeekZPge; AND_ end;
   $26 { ROL ZPge } : begin PeekZPge; ROL; PokeZPge; end;
{*}$27 { RLA ZPge } : begin PeekZPge; RLA; PokeZPge; end;
   $28 { PLP      } : PLP;
   $29 { AND Imm  } : begin Imm; AND_ end;
   $2A { ROL      } : begin LDA; ROL; STA('AL') end;
{*}$2B { ANC Imm  } : WriteLn('op2B equ op0B ; undocumented ANC');
   $2C { BIT Abso } : begin PeekAbso; BIT end;
   $2D { AND Abso } : begin PeekAbso; AND_ end;
   $2E { ROL Abso } : begin PeekAbso; ROL; PokeAbso end;
{*}$2F { RLA Abso } : begin PeekAbso; RLA; PokeAbso end;
   $30 { BMI Rela } : Branch('NFlag',True);
   $31 { AND IndY } : begin PeekIndY; AND_ end;
 { $32-JAM}
{*}$33 { RLA IndY } : begin PeekIndY; RLA; PokeIndY end;
{*}$34 { NOP      } : WriteLn('op34 equ op14 ; undocumented NOP');
   $35 { AND ZPgX } : begin PeekZPgX; AND_ end;
   $36 { ROL ZPgX } : begin PeekZPgX; ROL; PokeZPge end;
{*}$37 { RLA ZPgX } : begin PeekZPgX; RLA; PokeZPge end;
   $38 { SEC      } : SetFlag('CFlag',True);
   $39 { AND AbsY } : begin PeekAbsY; AND_ end;
{*}$3A { NOP      } : WriteLn('op3A equ opEA ; undocumented NOP');
{*}$3B { RLA AbsY } : begin PeekAbsY; RLA; PokeAbso; end;
{*}$3C { NOP      } : WriteLn('op3C equ op0C ; undocumented NOP');
   $3D { AND AbsX } : begin PeekAbsX; AND_ end;
   $3E { ROL AbsX } : begin PeekAbsX; ROL; PokeAbso; end;
{*}$3F { RLA AbsX } : begin PeekAbsX; RLA; PokeAbso; end;
   $40 { RTI      } : RTI;
   $41 { EOR IndX } : begin PeekIndX; EOR; end;
 { $42-JAM}
{*}$43 { SRE IndX } : begin PeekIndX; SRE; PokeIndX end;
{*}$44 { NOP      } : WriteLn('op44 equ op04 ; undocumented NOP');
   $45 { EOR ZPge } : begin PeekZPge; EOR; end;
   $46 { LSR ZPge } : begin PeekZPge; LSR; PokeZPge; end;
{*}$47 { SRE ZPge } : begin PeekZPge; SRE; PokeZPge; end;
   $48 { PHA      } : begin Push(' MOV AX,A'); Next end;
   $49 { EOR Imm  } : begin Imm; EOR end;
   $4A { LSR      } : begin LDA; LSR; STA('AL') end;
{*}$4B { ASR Imm  } : begin Imm; ASR; end;
   $4C { JMP Abso } : begin Header; WriteLn(' MOV PC,BX'); Next end;
   $4D { EOR Abso } : begin PeekAbso; EOR end;
   $4E { LSR Abso } : begin PeekAbso; LSR; PokeAbso; end;
{*}$4F { SRE Abso } : begin PeekAbso; SRE; PokeAbso; end;
   $50 { BVC      } : Branch('VFlag',False);
   $51 { EOR IndY } : begin PeekIndY; EOR end;
 { $52-JAM}
{*}$53 { SRE IndY } : begin PeekIndY; SRE; PokeIndY end;
{*}$54 { NOP      } : WriteLn('op54 equ op14 ; undocumented NOP');
   $55 { EOR ZPgX } : begin PeekZPgX; EOR end;
   $56 { LSR ZPgX } : begin PeekZPgX; LSR; PokeZPge end;
{*}$57 { SRE ZPgX } : begin PeekZPgX; SRE; PokeZPge end;
   $58 { CLI      } : SetFlag('IFlag',False);
   $59 { EOR AbsY } : begin PeekAbsY; EOR end;
{*}$5A { NOP      } : WriteLn('op5A equ opEA ; undocumented NOP');
{*}$5B { SRE AbsY } : begin PeekAbsY; SRE; PokeAbso; end;
{*}$5C { NOP      } : WriteLn('op5C equ op0C ; undocumented NOP');
   $5D { EOR AbsX } : begin PeekAbsX; EOR end;
   $5E { LSR AbsX } : begin PeekAbsX; LSR; PokeAbso end;
{*}$5F { SRE AbsX } : begin PeekAbsX; SRE; PokeAbso end;
   $60 { RTS      } : RTS;
   $61 { ADC IndX } : begin PeekIndX; ADC end;
 { $62-JAM}
{*}$63 { RRA IndX } : begin PeekIndX; RRA; PokeIndX; end;
{*}$64 { NOP      } : WriteLn('op64 equ op04 ; undocumented NOP');
   $65 { ADC ZPge } : begin PeekZPge; ADC end;
   $66 { ROR ZPge } : begin PeekZPge; ROR; PokeZPge end;
{*}$67 { RRA ZPge } : begin PeekZPge; RRA; PokeZPge end;
   $68 { PLA      } : begin Pop(' MOV BYTE PTR A,AL'); Set_NZ('AL'); Next end;
   $69 { ADC Imm  } : begin Imm; ADC end;
   $6A { ROR      } : begin LDA; ROR; STA('AL') end;
{*}$6B { ARR Imm  } : begin Fetch; ARR; end;
   $6C { JMP Ind  } : JMPInd;
   $6D { ADC Abso } : begin PeekAbso; ADC end;
   $6E { ROR Abso } : begin PeekAbso; ROR; PokeAbso end;
{*}$6F { RRA Abso } : begin PeekAbso; RRA; PokeAbso end;
   $70 { BVS      } : Branch('VFlag',True);
   $71 { ADC IndY } : begin PeekIndY; ADC end;
 { $72-JAM}
{*}$73 { RRA IndY } : begin PeekIndY; RRA; PokeIndY end;
{*}$74 { NOP      } : WriteLn('op74 equ op14 ; undocumented NOP');
   $75 { ADC ZPgX } : begin PeekZPgX; ADC end;
   $76 { ROR ZPgX } : begin PeekZPgX; ROR; PokeZPge; end;
{*}$77 { RRA ZPgX } : begin PeekZPgX; RRA; PokeZPge; end;
   $78 { SEI      } : SetFlag('IFlag',True);
   $79 { ADC AbsY } : begin PeekAbsY; ADC end;
{*}$7A { NOP      } : WriteLn('op7A equ opEA ; undocumented NOP');
{*}$7B { RRA AbsY } : begin PeekAbsY; RRA; PokeAbso end;
{*}$7C { NOP      } : WriteLn('op7C equ op0C ; undocumented NOP');
   $7D { ADC AbsX } : begin PeekAbsX; ADC end;
   $7E { ROR AbsX } : begin PeekAbsX; ROR; PokeAbso; end;
{*}$7F { RRA AbsX } : begin PeekAbsX; RRA; PokeAbso; end;
{*}$80 { NOP Imm  } : begin Header; WriteLn(' INC PC'); Next end;
   $81 { STA IndX } : begin LDA; PokeIndX; end;
{*}$82 { NOP Imm  } : WriteLn('op82 equ op80 ; undocumented NOP');
{*}$83 { SAX IndX } : begin SAX; PokeIndX end;
   $84 { STY ZPge } : begin LDY; PokeZPge; end;
   $85 { STA ZPge } : begin LDA; PokeZPge; end;
   $86 { STX ZPge } : begin LDX; PokeZPge; end;
{*}$87 { SAX ZPge } : begin SAX; PokeZPge; end;
   $88 { DEY      } : begin LDY; DEC_; STY('AL'); end;
{*}$89 { NOP Imm  } : WriteLn('op89 equ op80 ; undocumented NOP');
   $8A { TXA      } : begin LDX; STA('AL') end;
{*}$8B { ANE Imm  } : begin Imm; ANE; end;
   $8C { STY Abso } : begin LDY; PokeAbso; end;
   $8D { STA Abso } : begin LDA; PokeAbso; end;
   $8E { STX Abso } : begin LDX; PokeAbso; end;
{*}$8F { SAX Abso } : begin SAX; PokeAbso; end;
   $90 { BCC Rela } : Branch('CFlag',False);
   $91 { STA IndY } : begin LDA; PokeIndY; end;
 { $92-JAM}
{*}$93 { SHA IndY } : SHAIndY;
   $94 { STY ZPgX } : begin LDY; PokeZPgX; end;
   $95 { STA ZPgX } : begin LDA; PokeZPgX; end;
   $96 { STX ZPgY } : begin LDX; PokeZPgY; end;
{*}$97 { SAX ZPgY } : begin SAX; PokeZpgY; end;
   $98 { TYA      } : begin LDY; STA('AL') end;
   $99 { STA AbsY } : begin LDA; PokeAbsY; end;
   $9A { TXS      } : begin LDX; WriteLn(' MOV BYTE PTR S,AL'); Next; end;
{*}$9B { SHS AbsY } : SHSAbsY;
{*}$9C { SHY AbsX } : SHYAbsX;
   $9D { STA AbsX } : begin LDA; PokeAbsX; end;
{*}$9E { SHX AbsY } : SHXAbsY;
{*}$9F { SHA AbsY } : SHAAbsY;
   $A0 { LDY Imm  } : begin Fetch; STY('BL'); end;
   $A1 { LDA IndX } : begin PeekIndX; STA('AL') end;
   $A2 { LDX Imm  } : begin Fetch; STX('BL'); end;
{*}$A3 { LAX IndX } : begin PeekIndX; LAX('AL'); end;
   $A4 { LDY ZPge } : begin PeekZPge; STY('AL'); end;
   $A5 { LDA ZPge } : begin PeekZPge; STA('AL'); end;
   $A6 { LDX ZPge } : begin PeekZPge; STX('AL'); end;
{*}$A7 { LAX Zpge } : begin PeekZPge; LAX('AL'); end;
   $A8 { TAY      } : begin LDA; STY('AL') end;
   $A9 { LDA Imm  } : begin Fetch; STA('BL') end;
   $AA { TAX      } : begin LDA; STX('AL') end;
{*}$AB { LXA Imm  } : begin Imm; LXA; end;
   $AC { LDY Abso } : begin PeekAbso; STY('AL'); end;
   $AD { LDA Abso } : begin PeekAbso; STA('AL'); end;
   $AE { LDX Abso } : begin PeekAbso; STX('AL'); end;
{*}$AF { LAX Abso } : begin PeekAbso; LAX('AL'); end;
   $B0 { BCS Rela } : Branch('CFlag',True);
   $B1 { LDA IndY } : begin PeekIndY; STA('AL'); end;
 { $B2-JAM }
{*}$B3 { LAX IndY } : begin PeekIndY; LAX('AL'); end;
   $B4 { LDY ZPgX } : begin PeekZPgX; STY('AL'); end;
   $B5 { LDA ZPgX } : begin PeekZPgX; STA('AL'); end;
   $B6 { LDX ZPgY } : begin PeekZPgY; STX('AL'); end;
{*}$B7 { LAX ZPgY } : begin PeekZPgY; LAX('AL'); end;
   $B8 { CLV      } : SetFlag('VFlag',False);
   $B9 { LDA AbsY } : begin PeekAbsY; STA('AL'); end;
   $BA { TSX      } : begin Header; WriteLn(' MOV AX,S'); STX('AL'); end;
{*}$BB { LAS AbsY } : begin PeekAbsY; LAS end;
   $BC { LDY AbsX } : begin PeekAbsX; STY('AL'); end;
   $BD { LDA AbsX } : begin PeekAbsX; STA('AL'); end;
   $BE { LDX AbsY } : begin PeekAbsY; STX('AL'); end;
{*}$BF { LAX AbsY } : begin PeekAbsY; LAX('AL'); end;
   $C0 { CPY Imm  } : begin Fetch; CMP('Y,BL'); end;
   $C1 { CMP IndX } : begin PeekIndX; CMP('A,AL'); end;
{*}$C2 { NOP Imm  } : WriteLn('opC2 equ op80 ; undocumented NOP');
{*}$C3 { DCP IndX } : begin PeekIndX; DCP; PokeIndX end;
   $C4 { CPY ZPge } : begin PeekZPge; CMP('Y,AL'); end;
   $C5 { CMP ZPge } : begin PeekZPge; CMP('A,AL'); end;
   $C6 { DEC ZPge } : begin PeekZPge; DEC_; PokeZPge; end;
{*}$C7 { DCP ZPge } : begin PeekZPge; DCP; PokeZpge; end;
   $C8 { INY      } : begin LDY; INC_; STY('AL'); end;
   $C9 { CMP Imm  } : begin Fetch; CMP('A,BL'); end;
   $CA { DEX      } : begin LDX; DEC_; STX('AL'); end;
{*}$CB { SBX Imm  } : begin Fetch; SBX end;
   $CC { CPY Abso } : begin PeekAbso; CMP('Y,AL'); end;
   $CD { CMP Abso } : begin PeekAbso; CMP('A,AL'); end;
   $CE { DEC Abso } : begin PeekAbso; DEC_; PokeAbso; end;
{*}$CF { DCP Abso } : begin PeekAbso; DCP; PokeAbso; end;
   $D0 { BNE Rela } : Branch('ZFlag',False);
   $D1 { CMP IndY } : begin PeekIndY; CMP('A,AL'); end;
 { $D2-JAM }
{*}$D3 { DCP IndY } : begin PeekIndY; DCP; PokeIndY end;
{*}$D4 { NOP      } : WriteLn('opD4 equ op14 ; undocumented NOP');
   $D5 { CMP ZPgX } : begin PeekZPgX; CMP('A,AL'); end;
   $D6 { DEC ZPgX } : begin PeekZPgX; DEC_; PokeZPge; end;
{*}$D7 { DCP ZPgX } : begin PeekZPgX; DCP; PokeZPge; end;
   $D8 { CLD      } : SetFlag('DFlag',False);
   $D9 { CMP AbsY } : begin PeekAbsY; CMP('A,AL'); end;
{*}$DA { NOP      } : WriteLn('opDA equ opEA ; undocumented NOP');
{*}$DB { DCP AbsY } : begin PeekAbsY; DCP; PokeAbso; end;
{*}$DC { NOP      } : WriteLn('opDC equ op0C ; undocumented NOP');
   $DD { CMP AbsX } : begin PeekAbsX; CMP('A,AL'); end;
   $DE { DEC AbsX } : begin PeekAbsX; DEC_; PokeAbso; end;
{*}$DF { DCP AbsX } : begin PeekAbsX; DCP; PokeAbso; end;
   $E0 { CPX Imm  } : begin Fetch; CMP('X,BL'); end;
   $E1 { SBC IndX } : begin PeekIndX; SBC; end;
{*}$E2 { NOP Imm  } : WriteLn('opE2 equ op80 ; undocumented NOP');
{*}$E3 { ISB IndX } : begin PeekIndX; ISB; PokeIndX; end;
   $E4 { CPX ZPge } : begin PeekZPge; CMP('X,AL'); end;
   $E5 { SBC ZPge } : begin PeekZPge; SBC; end;
   $E6 { INC ZPge } : begin PeekZPge; INC_; PokeZPge; end;
{*}$E7 { ISB ZPge } : begin PeekZPge; ISB; PokeZpge; end;
   $E8 { INX      } : begin LDX; INC_; STX('AL'); end;
   $E9 { SBC Imm  } : begin Imm; SBC; end;
   $EA { NOP      } : begin Header; { nothing } Next; end;
{*}$EB { SBC Imm  } : WriteLn('opEB equ opE9 ; Undocumented SBC');
   $EC { CPX Abso } : begin PeekAbso; CMP('X,AL'); end;
   $ED { SBC Abso } : begin PeekAbso; SBC; end;
   $EE { INC Abso } : begin PeekAbso; INC_; PokeAbso; end;
{*}$EF { ISB Abso } : begin PeekAbso; ISB; PokeAbso; end;
   $F0 { BEQ Rela } : Branch('ZFlag',True);
   $F1 { SBC IndY } : begin PeekIndY; SBC; end;

   $F2 { Extension OpCode } : begin
    Header;
    WriteLn(' CMP BL,3');
    WriteLn(' JBE XCode');
    WriteLn('  JMP JAM');
    WriteLn(' XCode:');
    WriteLn(' XOR BH,BH');
    WriteLn('JMP32 EBX,CBM ;-- JMP [2*EBX+Offset CBM]');
   end;
(*
   $F2 { Extension OpCode } : begin
    if PC<$E000 then Halt(hJAM);
    Case Imm of
     $00 : begin
            Bank0^[$90]:=Bank0^[$90] or IEC.Output(Bank0^[$95],Bank0^[$A3] and $80);
            Exclude(P,CFg);
            PC:=$EDAC;
           end;
     $01 : begin
            Bank0^[$90]:=Bank0^[$90] or IEC.OutputATN(A{Bank0^[$95]});
            Exclude(P,CFg);
            PC:=$EDAC;
           end;

     $02 : begin
            Bank0^[$90]:=Bank0^[$90] or IEC.OutputSec(Bank0^[$95]);
            Exclude(P,CFg);
            PC:=$EDAC;
           end;

     $03 : begin
            Bank0^[$90]:=IEC.Input(A);
            Set_NZ(A);
            Exclude(P,CFg);
            PC:=$EDAC;
           end;
     else  Halt(hIEC);
    end;
   end;
*)
{*}$F3 { ISB IndY } : begin PeekIndY; ISB; PokeIndY end;
{*}$F4 { NOP      } : WriteLn('opF4 equ op14 ; undocumented NOP');
   $F5 { SBC ZPgX } : begin PeekZPgX; SBC end;
   $F6 { INC ZPgX } : begin PeekZPgx; INC_; PokeZPge; end;
{*}$F7 { ISB ZPgX } : begin PeekZPgx; ISB; PokeZPge; end;
   $F8 { SED      } : SetFlag('DFlag',True);{begin Header; WriteLn(' JMP JAM ; not supported !'); end;}
   $F9 { SBC AbsY } : begin PeekAbsY; SBC end;
{*}$FA { NOP      } : WriteLn('opFA equ opEA ; undocumented NOP');
{*}$FB { ISB AbsY } : begin PeekAbsY; ISB; PokeAbso; end;
{*}$FC { NOP      } : WriteLn('opFC equ op0C ; undocumented NOP');
   $FD { SBC AbsX } : begin PeekAbsX; SBC end;
   $FE { INC AbsX } : begin PeekAbsX; INC_; PokeAbso; end;
{*}$FF { ISB AbsX } : begin PeekAbsX; ISB; PokeAbso; end;
   else WriteLn('op',Hexa(IR),' equ JAM');
  end;
 end;

var
 sep:char;
begin
{ assign output }
 assign(output,'6510.asm'); rewrite(output);

{ init }
 lbl:=0;

{ header }
 writeln(';--- 6510 Emulation');
 writeln;

{ opTable }
 writeln('.DATA');
 writeln('Align 2');
 write  ('OpTable dw');
 for IR:=0 to 255 do begin
  if (IR>0)and(IR mod 8 = 0) then begin
   write(#13#10'        dw'); sep:=' ';
  end;
  write(sep,'op',Hexa(IR)); sep:=',';
 end;
 writeln;
 WriteLn(' CBM dw CBM0,CBM1,CBM2,CBM3,CBM4');
 WriteLn(' EXTRN Output:FAR');
 WriteLn(' EXTRN OutputATN:FAR');
 WriteLn(' EXTRN OutputSec:FAR');
 WriteLn(' EXTRN Input :FAR');
 WriteLn(' EXTRN ReadTape:FAR');

{ macro }
 writeln;
 WriteLn(';--- macro ---');
 writeln('.CODE');
 WriteLn;
 WriteLn('OpCode Macro Number');
 WriteLn(' Align 2');
 WriteLn(' op&Number:');
 WriteLn('EndM');
 WriteLn;
 WriteLn('Set_NZ Macro Reg');
 WriteLn('Local L1,L2,L3');
 WriteLn(' OR Reg,Reg');
 WriteLn(' JZ L1');
 WriteLn('  TEST Reg,NFlag');
 WriteLn('  JZ L2');
 WriteLn('   AND P,255-ZFlag');
 WriteLn('   OR  P,NFlag');
 WriteLn('  JMP L3');
 WriteLn('  L2:');
 WriteLn('   AND P,255-ZFlag-NFlag');
 WriteLn('  JMP L3');
 WriteLn(' L1:');
 WriteLn('  AND P,255-NFlag');
 WriteLn('  OR  P,ZFlag');
 WriteLn(' L3:');
 WriteLn('EndM');

{ opcodes }
 for IR:=0 to 255 do RunCPU;

 Writeln;
 WriteLn(';--- Extended OpCodes (F2)---');
 WriteLn('BEGINP CBM0 ; Output Byte to DISK');
 WriteLn(' AND P,255-CFlag');
 WriteLn('IF DEBUG');
 Writeln(' CALLP dbgOutput');
 WriteLn('ELSE');
 Writeln(' CALLP Output LED 2');
 WriteLn('ENDIF');
 WriteLn(' MOV PC,0EDACh');
 WriteLn(' XOR CX,CX');
 WriteLn(' JMP NEXT');
 WriteLn('CBM0 ENDP');
 Writeln;

 WriteLn('BEGINP CBM1 ; Output ATN to DISK');
 WriteLn(' AND P,255-CFlag');
 WriteLn('IF DEBUG');
 Writeln(' CALLP dbgOutputATN');
 WriteLn('ELSE');
 Writeln(' CALLP OutputATN');
 WriteLn('ENDIF');
 WriteLn(' MOV PC,0EDACh');
 WriteLn(' XOR CX,CX');
 WriteLn(' JMP NEXT');
 WriteLn('CBM1 ENDP');
 Writeln;

 WriteLn('BEGINP CBM2 ; Ouput SecAddr to DISK');
 WriteLn(' AND P,255-CFlag');
 WriteLn('IF DEBUG');
 Writeln(' CALLP dbgOutputSEC');
 WriteLn('ELSE');
 Writeln(' CALLP OutputSEC');
 WriteLn('ENDIF');
 WriteLn(' MOV PC,0EDACh');
 WriteLn(' XOR CX,CX');
 WriteLn(' JMP NEXT');
 WriteLn('CBM2 ENDP');
 Writeln;

 WriteLn('BEGINP CBM3 ; Input byte from DISK');
 WriteLn(' AND P,255-CFlag');
 WriteLn('IF DEBUG');
 Writeln(' CALLP dbgInput');
 WriteLn('ELSE');
 Writeln(' CALLP Input LED 5');
 WriteLn('ENDIF');
 WriteLn(' MOV AX,A');
 WriteLn(' SET_NZ AL');
 WriteLn(' MOV PC,0EDACh');
 WriteLn(' XOR CX,CX');
 WriteLn(' JMP NEXT');
 WriteLn('CBM3 ENDP');
 Writeln;

 WriteLn('BEGINP CBM4 ; Read Tape Block - F841 ');
 WriteLn(' CALLP ReadTape');
 WriteLn(' MOV PC,0F837h');
 WriteLn('CBM4 ENDP');
 WriteLn;

 WriteLn(';- ADC ---------------------------');
 WriteLn('BEGINP doADC');
 WriteLn('; AL=Value');
 WriteLn('; CX=OpCycles');
 WriteLn(' TEST P,DFlag');
 l1:=jump('jnz');

 WriteLn('; binary mode');
 WriteLn(' SHR P,1');
 WriteLn(' ADC AL,BYTE PTR A');
 WriteLn(' MOV BYTE PTR A,AL');
 WriteLn(' SETO AH');
 WriteLn(' RCL P,1');
 Set_NZ('AL');

 WriteLn(' TEST AH,1');
 WriteLn(' JZ  lbl',lbl); inc(lbl);
 WriteLn('  OR P,VFlag');
 WriteLn('  JMP lbl',lbl); inc(lbl);
 WriteLn(' lbl',lbl-2,':');
 WriteLn('  AND P,255-VFlag');
 WriteLn(' lbl',lbl-1,':');

 WriteLn(' RET');

 WriteLn('; decimal mode');
 target(l1);
 nz:=false; { ! }

 writeln(' mov ah,al');
 writeln(' mov bl,byte ptr a');

 Writeln('; ZFlag & VFlag : add binary');
 writeln(' mov bh,p');
 writeln(' shr bh,1');
 writeln(' adc ah,bl');
 writeln(' seto ah ; VFlag');
 l1:=jump('jnz');
 writeln(' or p,Zflag');
 l2:=jump('jmp');
 target(l1);
 writeln(' and p,255-ZFlag');
 target(l2);

 writeln(' test ah,1');
 l1:=jump('jz');
 writeln(' or p,VFlag');
 l2:=jump('jmp');
 target(l1);
 writeln(' and p,255-VFlag');
 target(l2);

 writeln(' mov ah,al');
 writeln(' mov bh,bl');
 writeln(' shr ah,4  ; High nybbles');
 writeln(' shr bh,4');
 writeln(' and al,15 ; Low  nybbles');
 writeln(' and bl,15');

 writeln(' mov dl,p  ; Adc low');
 writeln(' shr dl,1');
 writeln(' adc al,bl');

 writeln(' cmp al,9  ; low DBC');
 l1:=jump('jbe');
 writeln(' add al,6');
 target(l1);

 writeln(' add ah,bh ; Add High');

 writeln(' cmp al,15 ; Low carry');
 l1:=jump('jbe');
 writeln(' inc ah');
 target(l1);

 writeln('; NFlag : AH and 8h');
 writeln(' test ah,8');
 l1:=jump('jnz');
  writeln(' and p,255-NFlag');
  l2:=jump('jmp');
 target(l1);
  writeln(' or p,NFlag');
 target(l2);

 writeln(' cmp ah,9 ; High DBC');
 l1:=jump('jbe');
 writeln(' add ah,6');
 target(l1);

 writeln('; CFlag  : AH>15');
 writeln(' test ah,0F0h');
 l1:=jump('jnz');
  writeln(' and p,255-CFlag');
  l2:=jump('jmp');
 target(l1);
  writeln(' or p,CFlag');
 target(l2);

 writeln(' shl ah,4  ; Adjust High');
 writeln(' and al,15 ; Adjust Low');
 writeln(' or al,ah  ; DBC Result');

 writeln(' mov byte ptr a,al');
 writeln(' RET     ');
 writeln('doADC ENDP');
 Writeln;

 WriteLn(';- SBC ---------------------------');
 WriteLn('BEGINP doSBC');
 WriteLn('; AL=Value');
 WriteLn('; CX=OpCycles');

 WriteLn(' TEST P,DFlag');
 l1:=jump('jnz');

 WriteLn('; binary mode');

 WriteLn(' SHR P,1');
 WriteLn(' CMC ; NOT C');
 WriteLn(' MOV AH,BYTE PTR A');
 WriteLn(' SBB AH,AL');
 WriteLn(' MOV BYTE PTR A,AH');
 WriteLn(' SETO AL');
 WritELn(' CMC ; NOT C');
 WriteLn(' RCL P,1');
 Set_NZ('AH');
 WriteLn(' TEST AL,1');
 WriteLn(' JZ  lbl',lbl); inc(lbl);
 WriteLn('  OR P,VFlag');
 WriteLn('  JMP lbl',lbl); inc(lbl);
 WriteLn(' lbl',lbl-2,':');
 WriteLn('  AND P,255-VFlag');
 WriteLn(' lbl',lbl-1,':');

 WriteLn(' RET');

 WriteLn('; decimal mode');
 target(l1);
 nz:=false; { ! }

 writeln(' mov bl,byte ptr a');
 writeln(' mov bh,bl');
 writeln(' shr p,1');
 writeln(' setnc dl');
 writeln(' mov dh,dl');

 Writeln('; ZFlag & VFlag : sbb binary');
 writeln(' shr dh,1');
 writeln(' sbb bh,al');
 writeln(' seto ah ; VFlag');
 WriteLn(' CMC ; NOT C');
 writeln(' rcl p,1');

 Set_NZ('BH');

 writeln(' test ah,1');
 l1:=jump('jz');
 writeln(' or p,VFlag');
 l2:=jump('jmp');
 target(l1);
 writeln(' and p,255-VFlag');
 target(l2);

 writeln(' mov ah,al');
 writeln(' mov bh,bl');
 writeln(' shr ah,4  ; High nybbles');
 writeln(' shr bh,4');
 writeln(' and al,15 ; Low  nybbles');
 writeln(' and bl,15');

 writeln(' shr dl,1  ; Sbb low');
 writeln(' sbb bl,al');

 writeln(' sub bh,ah ; Sub High');

 writeln(' test bl,10h');
 l1:=jump('jz');
 writeln(' sub bl,6');
 writeln(' dec bh');
 target(l1);

 writeln(' test bh,10h');
 l1:=jump('jz');
 writeln(' sub bh,6');
 target(l1);

 writeln(' shl bh,4  ; Adjust High');
 writeln(' and bl,15 ; Adjust Low');
 writeln(' or  bl,bh ; DBC Result');

 writeln(' mov byte ptr a,bl');
 writeln(' RET');

 writeln('doSBC ENDP');

{ done }
 close(output);
end.
