Program KEYB64;

Const
 mapcount=89;

Type
 TKeyMap=array[1..mapcount,1..3] of  word;

Const

 qwerty:TKeyMap=(

 {                 CBM   PC   Ext }
 {
 {                  ....1=Shift
 {                  :    .........1=Shift,2=AltgGr,E=Extended,F=ShiftExtended
 { key              :    :    :
 {--------------------------------}
 { <-           } ($071,$029, $FF),
 { 1            } ($070,$002,$04F),
 { !            } ($170,$102, $FF),
 { 2            } ($073,$003,$050),
 { "            } ($173,$128, $FF),
 { 3            } ($010,$004,$051),
 { #            } ($110,$104, $FF),
 { 4            } ($013,$005,$04B),
 { $            } ($113,$105, $FF),
 { 5            } ($020,$006,$04C),
 { %            } ($120,$106, $FF),
 { 6            } ($023,$007,$04D),
 { &            } ($123,$108, $FF),
 { 7            } ($030,$008,$047),
 { '            } ($130,$028, $FF),
 { 8            } ($033,$009,$048),
 { (            } ($133,$10A, $FF),
 { 9            } ($040,$00A,$049),
 { )            } ($140,$10B, $FF),
 { 0            } ($043,$00B,$052),
 { +            } ($050,$10D,$04E),
 { -            } ($053,$00C,$04A),
 {             } ($060,$02B, $FF), { ?? }
 { home         } ($063,$F47, $FF),
 { clear        } ($163,$E47, $FF),
 { del          } ($000,$F53,$00E),
 { inst         } ($100,$F52, $FF),

 { ctrl         } ($072,$01D, $FF),
 { q            } ($076,$010, $FF),
 { w            } ($011,$011, $FF),
 { e            } ($016,$012, $FF),
 { r            } ($021,$013, $FF),
 { t            } ($026,$014, $FF),
 { y            } ($031,$015, $FF),
 { u            } ($036,$016, $FF),
 { i            } ($041,$017, $FF),
 { o            } ($046,$018, $FF),
 { p            } ($051,$019, $FF),
 { @            } ($056,$103, $FF),
 { *            } ($061,$109,$037),
 { arrowup      } ($066,$107, $FF),
 { stop         } ($077,$00F, $FF),
 { run          } ($177,$10F, $FF),
 { restore      } ($077,$001, $FF), { Esc - Stop + Restore(NMI) }
 { shiftlock    } ($175,$03A, $FF), { Shft + C= }
 { a            } ($012,$01E, $FF),
 { s            } ($015,$01F, $FF),
 { d            } ($022,$020, $FF),
 { f            } ($025,$021, $FF),
 { g            } ($032,$022, $FF),
 { h            } ($035,$023, $FF),
 { j            } ($042,$024, $FF),
 { k            } ($045,$025, $FF),
 { l            } ($052,$026, $FF),
 { :            } ($055,$027, $FF),
 { [            } ($155,$01A, $FF),
 { ;            } ($062,$127, $FF),
 { ]            } ($162,$01B, $FF),
 { =            } ($065,$00D, $FF),
 { return       } ($001,$01C,$E1C),

 { commodore    } ($075,$038, $FF),
 { shiftleft    } ($017,$02A, $FF),
 { z            } ($014,$02C, $FF),
 { x            } ($027,$02D, $FF),
 { c            } ($024,$02E, $FF),
 { v            } ($037,$02F, $FF),
 { b            } ($034,$030, $FF),
 { n            } ($047,$031, $FF),
 { m            } ($044,$032, $FF),
 { ,            } ($057,$033, $FF),
 { <            } ($157,$133, $FF),
 { .            } ($054,$034,$053),
 { >            } ($154,$134, $FF),
 { /            } ($067,$035,$E35),
 { ?            } ($167,$135, $FF),
 { shiftright   } ($064,$036, $FF),
 { down         } ($007,$F50, $FF),
 { up           } ($107,$F48, $FF),
 { right        } ($002,$F4D, $FF),
 { left         } ($102,$F4B, $FF),

 { f1           } ($004,$03B, $FF),
 { f2           } ($104,$03C, $FF),
 { f3           } ($005,$03D, $FF),
 { f4           } ($105,$03E, $FF),
 { f5           } ($006,$03F, $FF),
 { f6           } ($106,$040, $FF),
 { f7           } ($003,$041, $FF),
 { f8           } ($103,$042, $FF),

 { space        } ($074,$039, $FF)
 );

 azerty:TKeyMap=(

 { <-           } ($071,$029, $FF),
 { 1            } ($070,$102,$04F),
 { !            } ($170,$035, $FF),
 { 2            } ($073,$103,$050),
 { "            } ($173,$004, $FF),
 { 3            } ($010,$104,$051),
 { #            } ($110,$204, $FF),
 { 4            } ($013,$105,$04B),
 { $            } ($113,$01B, $FF),
 { 5            } ($020,$106,$04C),
 { %            } ($120,$128, $FF),
 { 6            } ($023,$107,$04D),
 { &            } ($123,$002, $FF),
 { 7            } ($030,$108,$047),
 { '            } ($130,$005, $FF),
 { 8            } ($033,$109,$048),
 { (            } ($133,$006, $FF),
 { 9            } ($040,$10A,$049),
 { )            } ($140,$00C, $FF),
 { 0            } ($043,$10B,$052),
 { +            } ($050,$10D,$04E),
 { -            } ($053,$007,$04A),
 {             } ($060,$11B, $FF),
 { home         } ($063,$F47, $FF),
 { clear        } ($163,$E47, $FF),
 { del          } ($000,$F53,$00E),
 { inst         } ($100,$F52, $FF),

 { ctrl         } ($072,$01D, $FF),
 { q            } ($076,$01E, $FF),
 { w            } ($011,$02C, $FF),
 { e            } ($016,$012, $FF),
 { r            } ($021,$013, $FF),
 { t            } ($026,$014, $FF),
 { y            } ($031,$015, $FF),
 { u            } ($036,$016, $FF),
 { i            } ($041,$017, $FF),
 { o            } ($046,$018, $FF),
 { p            } ($051,$019, $FF),
 { @            } ($056,$20B, $FF),
 { *            } ($061,$02B,$037),
 { arrowup      } ($066,$01A, $FF),
 { stop         } ($077,$00F, $FF),
 { run          } ($177,$10F, $FF),
 { restore      } ($077,$001, $FF), { Esc - Stop+Restore(NMI) }
 { shiftlock    } ($175,$03A, $FF), { Shft + C= }
 { a            } ($012,$010, $FF),
 { s            } ($015,$01F, $FF),
 { d            } ($022,$020, $FF),
 { f            } ($025,$021, $FF),
 { g            } ($032,$022, $FF),
 { h            } ($035,$023, $FF),
 { j            } ($042,$024, $FF),
 { k            } ($045,$025, $FF),
 { l            } ($052,$026, $FF),
 { :            } ($055,$034, $FF),
 { [            } ($155,$206, $FF),
 { ;            } ($062,$033, $FF),
 { ]            } ($162,$20C, $FF),
 { =            } ($065,$00D, $FF),
 { return       } ($001,$01C,$E1C),

 { commodore    } ($075,$038, $FF),
 { shiftleft    } ($017,$02A, $FF),
 { z            } ($014,$011, $FF),
 { x            } ($027,$02D, $FF),
 { c            } ($024,$02E, $FF),
 { v            } ($037,$02F, $FF),
 { b            } ($034,$030, $FF),
 { n            } ($047,$031, $FF),
 { m            } ($044,$027, $FF),
 { ,            } ($057,$032, $FF),
 { <            } ($157,$056, $FF),
 { .            } ($054,$133,$053),
 { >            } ($154,$156, $FF),
 { /            } ($067,$134,$E35),
 { ?            } ($167,$132, $FF),
 { shiftright   } ($064,$036, $FF),
 { down         } ($007,$F50, $FF),
 { up           } ($107,$F48, $FF),
 { right        } ($002,$F4D, $FF),
 { left         } ($102,$F4B, $FF),

 { f1           } ($004,$03B, $FF),
 { f2           } ($104,$03C, $FF),
 { f3           } ($005,$03D, $FF),
 { f4           } ($105,$03E, $FF),
 { f5           } ($006,$03F, $FF),
 { f6           } ($106,$040, $FF),
 { f7           } ($003,$041, $FF),
 { f8           } ($103,$042, $FF),

 { space        } ($074,$039, $FF)

 );

 joystick:array[1..5,1..2] of word=(
 { Up           } ($01,$E48), { cursor }
 { Down         } ($02,$E50),
 { Left         } ($04,$E4B),
 { Right        } ($08,$E4D),
 { Fire         } ($10,$E1D)  { RightCtrl  }
 );


const
 keycount=127;

type
 TKeyboard=array[1..keycount] of byte;

var
 keybd:TKeyboard;
 shift:TKeyboard;
 altgr:TKeyboard;
 xkeys:TKeyboard;
 xshft:TKeyboard;

 key:word;

 c64:word;
 pc :word;
 pcx:word;

 f:text;

function hexa(b:byte):string;
 const
  hx:array[0..$F] of char='0123456789ABCDEF';
 begin
  hexa:=hx[b shr 4]+hx[b and $F];
 end;


procedure dump(name:string;var keys:TKeyboard);
 var
  k:byte;
 begin
  write(f,' ',name,':array[1..',keycount,'] of byte=(');
  for k:=1 to keycount do begin
   if (k and 15)=1 then write(f,#13#10'  {',hexa(k),'}');
   write(f,'$',hexa(keys[k]));
   if k<keycount then write(f,',');
  end;

  writeln(f,' );');
 end;

procedure dumpkeys(keyboard:TKeyMap);
 begin
  fillchar(keybd,sizeof(keybd),$FF);
  fillchar(shift,sizeof(shift),$FF);
  fillchar(altgr,sizeof(altgr),$FF);
  fillchar(xkeys,sizeof(xkeys),$FF);

  for key:=1 to mapcount do begin
   c64:=keyboard[key,1];
   c64:=(c64 and $1F0) shr 1+(c64 and $00F);
   pc :=keyboard[key,2];
   pcx:=keyboard[key,3];

   case pc of
    $001..$0FF: keybd[pc]:=c64;
    $100..$1FF: shift[pc and $FF]:=c64;
    $200..$2FF: altgr[pc and $FF]:=c64;
    $E00..$EFF: xkeys[pc and $FF]:=c64;
    $F00..$FFF: xshft[pc and $FF]:=c64;
   end;

   case pcx of
    $001..$0FE: keybd[pcx]:=c64;
    $100..$1FF: shift[pcx and $FF]:=c64;
    $200..$2FF: altgr[pcx and $FF]:=c64;
    $E00..$EFF: xkeys[pcx and $FF]:=c64;
    $F00..$FFF: xshft[pcx and $FF]:=c64;
   end;

  end;

 { joystick }
  for key:=1 to 5 do begin
   c64:=joystick[key,1] or $40;
   pc :=joystick[key,2];
   case pc of
    $E00..$EFF: xkeys[pc and $FF]:=c64;
    $F00..$FFF: xshft[pc and $FF]:=c64;
   end;
  end;

 { fill shift table }
  for key:=1 to keycount do begin
   if (shift[key]=255)
   and(keybd[key]<255)
   and(keybd[key]>0) then shift[key]:=byte(keybd[key]+128);
  end;

  dump('keybd',keybd);
  dump('shift',shift);
  dump('altgr',altgr);
  dump('xkeys',xkeys);
  dump('xshft',xshft);
 end;


begin
 assign(f,'keyb.pas');
 rewrite(f);

 writeln(f,'{ KEYBOARD TABLES }');
 writeln(f,'Const');
 writeln(f,'{$IFDEF QWERTY - US Keyboard}');

  dumpkeys(qwerty);

 writeln(f,'{$ELSE AZERTY - French Keyboard}');

  dumpkeys(azerty);

 writeln(f,'{$ENDIF}');

 close(f);
end.
(*
 The commodore 64 :

Ŀ
Ŀ                Ŀ   
C= commodore  64                power    
                   
͵
                                                   
Ŀ
   Ŀ  Ŀ 
     !"#$%&'()    Clr INS  F2 
   <-1234567890+-HomeDEL  F1 
   Ĵ  Ĵ 
                            F4 
   CTLQWERTYUIOP@*RESTORE  F3 
  Ĵ 
RUNSFT         []           F6 
STPLCKASDFGHJKL:;=RETURN    F5 
Ĵ    Ĵ 
              <>?         F8 
C=SHIFTZXCVBNM,./SHIFT    F7 
     
                                               
                              
ٳ
;


 The commodore 64 key matrix (Col/Row : Matrix[Col]=1^Row )

Ŀ
Ŀ                Ŀ   
C= commodore  64                power    
                   
͵
                                                   
Ŀ
   Ŀ  Ŀ 
   7 7711223344556 6   0   0  
   1 0303030303030 3   0   4  
   Ĵ  Ĵ 
    7 7112233445566         0  
    2 6161616161616RESTORE  5    RESTORE = NMI
  Ĵ 
 7 SFT112233445566  0       0  
 7 LCK252525252525  1       6    SHIFT LOCK = SHIFT ?
Ĵ    Ĵ 
7   1  1223344556  6  00    0  
5   7  4747474747  4  72    3  
     
               7/4                             
                              
ٳ
;

	C64 keyboard matrix:
    Ŀ
 Bit 7  6  5  4  3  2  1  0 
Ĵ
 0    F5 F3 F1 F7  RETDEL
 1 SHL E  S  Z  4  A  W  3 
 2  X  T  F  C  6  D  R  5 
 3  V  U  H  B  8  G  Y  7 
 4  N  O  K  M  0  J  I  9 
 5  ,  @  :  .  -  L  P  + 
 6  /  ^  = SHRHOM ;  *   
 7 R/S Q  C=SPC 2 CTL <- 1 


 MATRIX(a,b)=(a shl 3) or b;

	'0' = MATRIX(4,3);
	'1' = MATRIX(7,0);
	'2' = MATRIX(7,3);
	'3' = MATRIX(1,0);
	'4' = MATRIX(1,3);
	'5' = MATRIX(2,0);
	'6' = MATRIX(2,3);
	'7' = MATRIX(3,0);
	'8' = MATRIX(3,3);
	'9' = MATRIX(4,0);


 Now my French (AZERTY) PC Keyboard
Ŀ
 Ŀ  Ŀ Ŀ Ŀ Ŀ               
                                PrSc                 
 Es  F1F2F3F4 F5F6F7F8 F9101112 ScLkPs               
                     
  Ŀ Ŀ Ŀ 
    1 2 3 4 5 6 7 8 9 0  +              Nm       
   & ~"#'{([-|`_\^@)]=} <  InHmUp Lk/ * -  
 Ĵ Ĵ Ĵ 
 <     	                	   	   7 8 9    
  >A Z E R T Y U I O P ^ $  RET DlEdDw Hm Up   
      Ĵ+  
 SHFT               	    %  <ٳ	     4 5 6    
 LOCK Q S D F G H J K L M  *                       
 Ĵ    Ŀ    Ĵ 
     >             ? . /                   1 2 3    
 SHT < W X C V B N , ; : ! SHT             Ed Dw   
 Ĵ Ŀ ĴRt 
           		Alt     	   	   0    .    
 CtrlMSAlt 		Gr MSMnuCtrl     Ins  Dl   
    
                                                                          

 And the Scan codes (hexa)
Ŀ
 Ŀ	Ŀ Ŀ Ŀ Ŀ		   
                                Pr  E0               
 01  3B3C3D3E 3F404142 43445758 Sc4646               
                     
  Ŀ Ŀ Ŀ 
              	            	 E0E0E0 	E0     
  2902030405060708090A0B0C0D 0E   524749 4535374A 
 Ĵ Ĵ Ĵ 
         	              	  	 E0E0E0 	       
 0F  101112131415161718191A1B 1C  534F51 474849   
      Ĵ4E 
                                                      
 3A   1E1F2021222324252627282B               4B4C4D   
 Ĵ    Ŀ    Ĵ 
         	              		    E0    	       
 2A  562C2D2E2F303132333435 36	    48    4F5051E0 
 Ĵ Ŀ Ĵ1C 
           		E0   E0  E0  E0E0E0 	        
 1D  ??38     39		38 ??5D  1D  4B504D  52  53   
    
                                                                          


 And an US Keyboard by Brad Martin (Free64) a cool guy :)
Ŀ
 Ŀ  Ŀ ĿĿ Ŀ                
                               PrSc                  
 Es  F1F2F3F4 F5F6F7F8F9101112 ScLkPs                
                     
 Ŀ Ŀ Ŀ 
 ~ ! @ # $ % ^ & * ( ) _ + |            Nm       
 ` 1 2 3 4 5 6 7 8 9 0 - = \ <-  InHmUp Lk/ * -  
 Ĵ Ĵ Ĵ 
 |<-                     [ ]             7 8 9    
 ->| Q W E R T Y U I O P { }      DlEdDw Hm Up   
       Ĵ+  
 CAPS                   ; ' ENTER             4 5 6    
 LOCK A S D F G H J K L : " <                      
 Ĵ    Ŀ    Ĵ 
                      < > ?                  1 2 3    
  SHIFT Z X C V B N M , . /  SHIFT          Ed Dw   
 Ĵ Ŀ ĴEn 
                                               0    .    
 CtrlMSAlt                 AltMSMnuCtrl     Ins  Dl   
    
                                                                          


 Now my "French" (QWERTY) PC Keyboard
Ŀ
 Ŀ  Ŀ Ŀ Ŀ Ŀ               
                                PrSc                 
 Es  F1F2F3F4 F5F6F7F8 F9101112 ScLkPs               
                     
  Ŀ Ŀ Ŀ 
  ~ ! @ # $ % ^ & * ( ) _ +              Nm       
  ` 1 2 3 4 5 6 7 8 9 0 - =  <  InHmUp Lk/ * -  
 Ĵ Ĵ Ĵ 
 <     	              { } 	   	   7 8 9    
  >Q W E R T Y U I O P [ ]  RET DlEdDw Hm Up   
      Ĵ+  
 SHFT               	  : " | <ٳ	     4 5 6    
 LOCK A S D F G H J K L ; ' \                       
 Ĵ    Ŀ    Ĵ 
     |               < > ?                  1 2 3    
 SHT \ Z X C V B N M , . / SHT             Ed Dw   
 Ĵ Ŀ ĴRt 
           		Alt     	   	   0    .    
 CtrlMSAlt 		Gr MSMnuCtrl     Ins  Dl   
    
                                                                          


 Hey ! there's a key that appear twice !

*)
